/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 */

package com.jcg.flatmapchainingexample;

import java.util.Optional;

/**
 *
 * @author omozegieaziegbe
 */
public class FlatMapChainingExample {

    public static void main(String[] args) {
        
        Optional<String> firstName = Optional.of("Alice");
        Optional<String> lastName = Optional.of("Doe");
        Optional<String> email = Optional.of("alice.doe@jcg.com");

        firstName.flatMap(fn -> lastName.flatMap(ln -> email.map(em -> createUserProfile(fn, ln, em))))
                 .ifPresentOrElse(
                     System.out::println,
                     () -> System.out.println("One or more required fields are missing")
                 );
    }

    private static String createUserProfile(String firstName, String lastName, String email) {
        return "User Profile: " + firstName + " " + lastName + ", Email: " + email;
    }
}
