/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 */
package com.jcg.optionalstreamexample;

import java.util.Optional;
import java.util.stream.Stream;

/**
 *
 * @author omozegieaziegbe
 */
public class OptionalStreamExample {

    public static void main(String[] args) {
        Optional<String> firstName = Optional.of("Alice");
        Optional<String> lastName = Optional.of("Doe");
        Optional<String> email = Optional.of("alice.doe@jcg.com");

        boolean allPresent = Stream.of(firstName, lastName, email)
                                   .allMatch(Optional::isPresent);

        if (allPresent) {
            String userProfile = createUserProfile(
                firstName.get(),
                lastName.get(),
                email.get()
            );
            System.out.println(userProfile);
        } else {
            System.out.println("One or more required fields are missing");
        }
    }

    private static String createUserProfile(String firstName, String lastName, String email) {
        return "User Profile: " + firstName + " " + lastName + ", Email: " + email;
    }
}